| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::ChannelTypeDBusTubeInterface Class Reference
Channel proxies

`#include <TelepathyQt/Channel>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply< QString > Offer (const QVariantMap &parameters, uint accesscontrol, int timeout=-1)
- QDBusPendingReply< QString > Accept (uint accesscontrol, int timeout=-1)

## Signals

- void DBusNamesChanged (const Tp::DBusTubeParticipants &added, const Tp::UIntList &removed)

## Public Member Functions

- ChannelTypeDBusTubeInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelTypeDBusTubeInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelTypeDBusTubeInterface (Tp::DBusProxy *proxy)
- ChannelTypeDBusTubeInterface (const Tp::Client::ChannelInterface &mainInterface)
- ChannelTypeDBusTubeInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
- Tp::PendingVariant * requestPropertyServiceName () const
- Tp::PendingVariant * requestPropertyDBusNames () const
- Tp::PendingVariant * requestPropertySupportedAccessControls () const
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Type.DBusTube".

## Constructor & Destructor Documentation

Tp::Client::ChannelTypeDBusTubeInterface::ChannelTypeDBusTubeInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeDBusTubeInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelTypeDBusTubeInterface::ChannelTypeDBusTubeInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeDBusTubeInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelTypeDBusTubeInterface::ChannelTypeDBusTubeInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelTypeDBusTubeInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ChannelTypeDBusTubeInterface::ChannelTypeDBusTubeInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) | `[explicit]`

Creates a ChannelTypeDBusTubeInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::ChannelTypeDBusTubeInterface::ChannelTypeDBusTubeInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelTypeDBusTubeInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelTypeDBusTubeInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Type.DBusTube", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ChannelTypeDBusTubeInterface::requestPropertyServiceName | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `ServiceName` of type `QString`.

A string representing the service name that will be used over the tube. It SHOULD be a well-known D-Bus service name, of the form `com.example.ServiceName`.

When the tube is offered, the service name is transmitted to the other end.

When requesting a channel with ConnectionInterfaceRequestsInterface::CreateChannel() , this property MUST be included in the request.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelTypeDBusTubeInterface::requestPropertyDBusNames | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `DBusNames` of type `Tp::DBusTubeParticipants`.

For a multi-user (i.e. Handle_Type_Room) D-Bus tube, a mapping between contact handles and their unique bus names on this tube. For a peer-to-peer (i.e. Handle_Type_Contact) D-Bus tube, the empty dictionary. Change notification is via DBusNamesChanged.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelTypeDBusTubeInterface::requestPropertySupportedAccessControls | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `SupportedAccessControls` of type `Tp::UIntList`.

A list of the access control types that are supported with this channel. Note that only Socket_Access_Control_Localhost and Socket_Access_Control_Credentials can be used with D-Bus tubes. Using Socket_Access_Control_Credentials is recommended.

Socket_Access_Control_Credentials is easy to implement for a D-Bus tube, because typical D-Bus library implementations like libdbus and GDBus already have to support it to be able to connect to the system or session bus, and usually enable it by default; so there's typically no good reason to relax access control to Localhost.

When requesting a channel with ConnectionInterfaceRequestsInterface::CreateChannel() , this property MUST NOT be included in the request.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ChannelTypeDBusTubeInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<QString> Tp::Client::ChannelTypeDBusTubeInterface::Offer | ( | const QVariantMap & | parameters,
|  | uint | accesscontrol,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `Offer` on the remote object.

Offers a D-Bus tube providing the service specified.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  parameters | The dictionary of arbitrary Parameters to send with the tube offer.
  accesscontrol | The access control the connection manager applies to the D-Bus socket.
  timeout | The timeout in milliseconds.

Returns:

The string describing the address of the private bus. The client SHOULD NOT attempt to connect to the address until the tube is open.

QDBusPendingReply<QString> Tp::Client::ChannelTypeDBusTubeInterface::Accept | ( | uint | accesscontrol,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `Accept` on the remote object.

Accept a D-Bus tube that's in the "local pending" state. The connection manager will attempt to open the tube. The tube remains in the "local pending" state until the TubeChannelStateChanged signal is emitted.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  accesscontrol | The access control the connection manager applies to the D-Bus socket.
  timeout | The timeout in milliseconds.

Returns:

The string describing the address of the private bus. The client SHOULD NOT attempt to connect to the address until the tube is open.

void Tp::Client::ChannelTypeDBusTubeInterface::DBusNamesChanged | ( | const Tp::DBusTubeParticipants & | added,
|  | const Tp::UIntList & | removed
| ) |  | `[signal]`

Represents the signal `DBusNamesChanged` on the remote object.

Emitted on a multi-user (i.e. Handle_Type_Room) D-Bus tube when a participant opens or closes the tube. This provides change notification for the DBusNames property.

Parameters:

  added | Array of handles and D-Bus names of new participants.
  removed | Array of handles of former participants.

void Tp::Client::ChannelTypeDBusTubeInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.